## ignition-msgs 0.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)

project (ignition-msgs0)

string (SUBSTRING ${PROJECT_NAME} 9 4 IGN_PROJECT_NAME)

string (SUBSTRING ${PROJECT_NAME} 13 -1 PROJECT_MAJOR_VERSION)
set (PROJECT_MINOR_VERSION 5)
set (PROJECT_PATCH_VERSION 0)

set(PROJECT_NAME_NO_VERSION "ignition-${IGN_PROJECT_NAME}")
string (TOLOWER ${PROJECT_NAME_NO_VERSION} PROJECT_NAME_NO_VERSION_LOWER)
string (TOUPPER ${PROJECT_NAME_NO_VERSION} PROJECT_NAME_NO_VERSION_UPPER)
string (TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)
string (TOUPPER ${PROJECT_NAME} PROJECT_NAME_UPPER)
set(PROJECT_EXPORT_NAME ${PROJECT_NAME_LOWER})
set(PROJECT_LIBRARY_TARGET_NAME ${PROJECT_NAME_LOWER})

set (PROJECT_VERSION ${PROJECT_MAJOR_VERSION}.${PROJECT_MINOR_VERSION})
set (PROJECT_VERSION_FULL
  ${PROJECT_MAJOR_VERSION}.${PROJECT_MINOR_VERSION}.${PROJECT_PATCH_VERSION})


message (STATUS "${PROJECT_NAME_NO_VERSION} version ${PROJECT_VERSION_FULL}")

set (project_cmake_dir ${PROJECT_SOURCE_DIR}/cmake
  CACHE PATH "Location of CMake scripts")

include (${project_cmake_dir}/Utils.cmake)
include (CMakePackageConfigHelpers)

########################################
# Package Creation:
include (${project_cmake_dir}/cpack.cmake)
set (CPACK_PACKAGE_VERSION "${PROJECT_VERSION_FULL}")
set (CPACK_PACKAGE_VERSION_MAJOR "${PROJECT_MAJOR_VERSION}")
set (CPACK_PACKAGE_VERSION_MINOR "${PROJECT_MINOR_VERSION}")
set (CPACK_PACKAGE_VERSION_PATCH "${PROJECT_PATCH_VERSION}")

if (CPACK_GENERATOR)
  message(STATUS "Found CPack generators: ${CPACK_GENERATOR}")

  configure_file("${project_cmake_dir}/cpack_options.cmake.in"
    ${PROJECT_CPACK_CFG_FILE} @ONLY)

  set(CPACK_PROJECT_CONFIG_FILE ${PROJECT_CPACK_CFG_FILE})
  include (CPack)
endif()

# If we're configuring only to package source, stop here
if (PACKAGE_SOURCE_ONLY)
  message(WARNING "Configuration was done in PACKAGE_SOURCE_ONLY mode."
  "You can build a tarball (make package_source), but nothing else.")
  return()
endif()

#################################################
# Documentation:
add_subdirectory(doc)

# Configure documentation uploader
configure_file("${project_cmake_dir}/upload_doc.sh.in"
  ${CMAKE_BINARY_DIR}/upload_doc.sh @ONLY)

# If we're configuring only to build docs, stop here
if (DOC_ONLY)
  message(WARNING "Configuration was done in DOC_ONLY mode."
  " You can build documentation (make doc), but nothing else.")
  return()
endif()

enable_testing()

# Use GNUInstallDirst to get canonical paths
include(GNUInstallDirs)

# with -fPIC
if(UNIX AND NOT WIN32)
  set (CMAKE_INSTALL_PREFIX "/usr" CACHE STRING "Install Prefix")
 find_program(CMAKE_UNAME uname /bin /usr/bin /usr/local/bin )
 if(CMAKE_UNAME)
   exec_program(uname ARGS -m OUTPUT_VARIABLE CMAKE_SYSTEM_PROCESSOR)
   set(CMAKE_SYSTEM_PROCESSOR ${CMAKE_SYSTEM_PROCESSOR} CACHE INTERNAL
     "processor type (i386 and x86_64)")
   if(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64")
     ADD_DEFINITIONS(-fPIC)
   endif(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64")
 endif(CMAKE_UNAME)
endif()

set (CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

# developer's option to cache PKG_CONFIG_PATH and
# LD_LIBRARY_PATH for local installs
if(PKG_CONFIG_PATH)
  set (ENV{PKG_CONFIG_PATH} ${PKG_CONFIG_PATH}:$ENV{PKG_CONFIG_PATH})
endif()
if(LD_LIBRARY_PATH)
  set (ENV{LD_LIBRARY_PATH} ${LD_LIBRARY_PATH}:$ENV{LD_LIBRARY_PATH})
endif()


set (INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_INCLUDEDIR}")
set (INCLUDE_INSTALL_DIR_POSTFIX 
  "ignition/${IGN_PROJECT_NAME}${PROJECT_MAJOR_VERSION}")
set (INCLUDE_INSTALL_DIR_FULL
  "${INCLUDE_INSTALL_DIR}/${INCLUDE_INSTALL_DIR_POSTFIX}")
set (LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR})
set (BIN_INSTALL_DIR ${CMAKE_INSTALL_BINDIR})

set (USE_FULL_RPATH OFF CACHE BOOL "Set to true to enable full rpath")

if (USE_FULL_RPATH)
  # use, i.e. don't skip the full RPATH for the build tree
  set(CMAKE_SKIP_BUILD_RPATH  FALSE)

  # when building, don't use the install RPATH already
  # (but later on when installing)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")

  # add the automatically determined parts of the RPATH
  # which point to directories outside the build tree to the install RPATH
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

  # the RPATH to be used when installing, but only if its not a system directory
  list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}" isSystemDir)
  if("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
  endif("${isSystemDir}" STREQUAL "-1")
endif()

set (BUILD_IGNITION ON CACHE INTERNAL
  "Build Ignition Msgs" FORCE)
set (build_errors "" CACHE INTERNAL "build errors" FORCE)
set (build_warnings "" CACHE INTERNAL "build warnings" FORCE)

include (${project_cmake_dir}/DissectVersion.cmake)

message (STATUS "\n\n====== Finding 3rd Party Packages ======")
include (${project_cmake_dir}/SearchForStuff.cmake)
message (STATUS "----------------------------------------\n")

#####################################
MESSAGE(STATUS "Checking ignition build type")
# Set the default build type
if (NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
        "Choose the type of build, options are: Debug Release RelWithDebInfo Profile Check" FORCE)
endif (NOT CMAKE_BUILD_TYPE)
# TODO: still convert to uppercase to keep backwards compatibility with
# uppercase old supported and deprecated modes
string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE_UPPERCASE)

set (BUILD_TYPE_PROFILE FALSE)
set (BUILD_TYPE_RELEASE FALSE)
set (BUILD_TYPE_RELWITHDEBINFO FALSE)
set (BUILD_TYPE_DEBUG FALSE)

if ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "PROFILE")
  set (BUILD_TYPE_PROFILE TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "RELEASE")
  set (BUILD_TYPE_RELEASE TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "RELWITHDEBINFO")
  set (BUILD_TYPE_RELWITHDEBINFO TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "DEBUG")
  set (BUILD_TYPE_DEBUG TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "COVERAGE")
  include (${project_cmake_dir}/CodeCoverage.cmake)
  set (BUILD_TYPE_DEBUG TRUE)
  SETUP_TARGET_FOR_COVERAGE(coverage ctest coverage)
else()
  build_error("CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} unknown. Valid options are: Debug Release RelWithDebInfo Profile Check")
endif()

#####################################
# Handle CFlags
unset (CMAKE_C_FLAGS_ALL CACHE)
unset (CMAKE_CXX_FLAGS CACHE)

# Check if warning options are avaliable for the compiler and return WARNING_CXX_FLAGS variable
# MSVC generates tons of warnings on gtest code.
# Recommended to use /W4 instead of /Wall
if (MSVC)
  set(WARN_LEVEL "/W2")
else()
  set(WARN_LEVEL "-Wall")
endif()

filter_valid_compiler_warnings(${WARN_LEVEL} -Wextra -Wno-long-long
  -Wno-unused-value -Wno-unused-value -Wno-unused-value -Wno-unused-value
  -Wfloat-equal -Wshadow -Winit-self -Wswitch-default
  -Wmissing-include-dirs -pedantic)
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}${WARNING_CXX_FLAGS}")
if (DEFINED EXTRA_CMAKE_CXX_FLAGS)
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_CMAKE_CXX_FLAGS}")
endif()

#################################################
# OS Specific initialization
if (UNIX)
  ign_setup_unix()
else (WIN32)
  ign_setup_windows()
endif()

if(APPLE)
  ign_setup_apple()
endif()

#################################################
# Print warnings and errors
if ( build_warnings )
  message(STATUS "BUILD WARNINGS")
  foreach (msg ${build_warnings})
    message(STATUS ${msg})
  endforeach ()
  message(STATUS "END BUILD WARNINGS\n")
endif (build_warnings)

########### Add uninstall target ###############
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P
  "${CMAKE_CURRENT_BINARY_DIR}/cmake/cmake_uninstall.cmake")

if (build_errors)
  message(STATUS "BUILD ERRORS: These must be resolved before compiling.")
  foreach (msg ${build_errors})
    message(STATUS ${msg})
  endforeach ()
  message(STATUS "END BUILD ERRORS\n")
  message (FATAL_ERROR "Errors encountered in build. "
      "Please see the BUILD ERRORS above.")
else (build_errors)

  ########################################
  # Write the config.h file
  configure_file ("${project_cmake_dir}/config.hh.in"
    "${PROJECT_BINARY_DIR}/include/ignition/${IGN_PROJECT_NAME}/config.hh")
  ign_install_includes(
    "${INCLUDE_INSTALL_DIR_POSTFIX}/ignition/${IGN_PROJECT_NAME}"
    "${PROJECT_BINARY_DIR}/include/ignition/${IGN_PROJECT_NAME}/config.hh")

  include_directories(
    ${PROJECT_SOURCE_DIR}
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_BINARY_DIR}
    ${PROJECT_BINARY_DIR}/include
    ${PROJECT_BINARY_DIR}/ignition/msgs
    ${IGNITION-MATH_INCLUDE_DIRS}
  )
  link_directories(${PROJECT_BINARY_DIR}/src ${IGNITION-MATH_LINK_DIRS})

  if (DEFINED CMAKE_CXX_FLAGS)
    message (STATUS "Custom CFlags:${CMAKE_CXX_FLAGS}")
  else()
    message (STATUS "Use default CFlags")
  endif()
  message (STATUS "Build Type: ${CMAKE_BUILD_TYPE}")
  message (STATUS "Install path: ${CMAKE_INSTALL_PREFIX}")


  if (BUILD_IGNITION)
    set(TEST_TYPE "UNIT")
    add_subdirectory(ignition/msgs)
    add_subdirectory(src)
    add_subdirectory(include)
    add_subdirectory(test)
    add_subdirectory(conf)
  endif (BUILD_IGNITION)

  ########################################
  # Make the package config files
  set (pkgconfig_files ${PROJECT_NAME_NO_VERSION_LOWER})

  foreach (pkgconfig ${pkgconfig_files})
    configure_file(${CMAKE_SOURCE_DIR}/cmake/pkgconfig/${pkgconfig}.in
      ${CMAKE_CURRENT_BINARY_DIR}/cmake/pkgconfig/${pkgconfig}${PROJECT_MAJOR_VERSION}.pc @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cmake/pkgconfig/${pkgconfig}${PROJECT_MAJOR_VERSION}.pc
      DESTINATION ${LIB_INSTALL_DIR}/pkgconfig COMPONENT pkgconfig)
  endforeach()

  ########################################
  # Make the cmake config files
  set(PKG_NAME ${PROJECT_NAME_NO_VERSION_UPPER})
  set(cmake_conf_file "${PROJECT_NAME_LOWER}-config.cmake")
  set(cmake_conf_version_file "${PROJECT_NAME_LOWER}-config-version.cmake")
  set(cmake_targets_file      "${PROJECT_NAME_LOWER}-targets.cmake")

  set(PKG_DEPENDS)

  if(WIN32 AND NOT CYGWIN)
    set(CMAKE_CONFIG_INSTALL_DIR CMake)
  else()
    set(CMAKE_CONFIG_INSTALL_DIR
      ${LIB_INSTALL_DIR}/cmake/${PROJECT_NAME_LOWER}/)
  endif()

  configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/ignition-config.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/${cmake_conf_file}"
    PATH_VARS LIB_INSTALL_DIR INCLUDE_INSTALL_DIR_FULL
    INSTALL_DESTINATION ${CMAKE_CONFIG_INSTALL_DIR})

  # Use write_basic_package_version_file to generate a ConfigVersion file that
  # allow users of gazebo to specify the API or version to depend on
  # TODO: keep this instruction until deprecate Ubuntu/Precise and update with
  # https://github.com/Kitware/CMake/blob/v2.8.8/Modules/CMakePackageConfigHelpers.cmake
  include(WriteBasicConfigVersionFile)
  write_basic_config_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/${cmake_conf_version_file}
    VERSION "${PROJECT_VERSION_FULL}"
    COMPATIBILITY SameMajorVersion)

  install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/${cmake_conf_file}
    ${CMAKE_CURRENT_BINARY_DIR}/${cmake_conf_version_file}
    DESTINATION ${CMAKE_CONFIG_INSTALL_DIR} COMPONENT cmake)
    
  # Create *-targets.cmake file for build directory
  # TODO: keep this instruction until we depend on CMake 3
  #       then change the first line from TARGETS ...  
  #       to EXPORT ... to match the format used in install(EXPORT
  export(TARGETS ${PROJECT_LIBRARY_TARGET_NAME}
         FILE  ${CMAKE_BINARY_DIR}/${cmake_targets_file})

  # Install *-targets.cmake file
  install(EXPORT ${PROJECT_EXPORT_NAME}
          DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
          FILE ${cmake_targets_file})

  ########################################

=== ignition/msgs/CMakeLists.txt ===
include_directories(${PROTOBUF_INCLUDE_DIRS})

set (msgs
altimeter.proto
any.proto
atmosphere.proto
axis.proto
battery.proto
boolean.proto
boxgeom.proto
bytes.proto
camera_cmd.proto
camera_lens.proto
camerasensor.proto
cessna.proto
clock.proto
cmd_vel2d.proto
collision.proto
color.proto
contact.proto
contactsensor.proto
contacts.proto
cylindergeom.proto
density.proto
diagnostics.proto
distortion.proto
double.proto
double_v.proto
duration.proto
empty.proto
entity_factory.proto
float.proto
float_v.proto
fluid.proto
fog.proto
friction.proto
geometry.proto
gps.proto
gps_sensor.proto
gui_camera.proto
gui.proto
header.proto
heightmapgeom.proto
hydra.proto
imagegeom.proto
image.proto
images_stamped.proto
image_stamped.proto
imu.proto
imu_sensor.proto
inertial.proto
int32.proto
int32_v.proto
int64.proto
int64_v.proto
joint_animation.proto
joint_cmd.proto
joint.proto
joint_wrench.proto
joint_wrench_stamped.proto
joystick.proto
laserscan.proto
laserscan_stamped.proto
light.proto
link_data.proto
link.proto
log_control.proto
logical_camera_image.proto
logical_camera_sensor.proto
log_playback_control.proto
log_playback_stats.proto
log_status.proto
magnetometer.proto
marker.proto
marker_v.proto
material.proto
meshgeom.proto
model_configuration.proto
model.proto
model_v.proto
packet.proto
param.proto
param_v.proto
physics.proto
pid.proto
planegeom.proto
plugin.proto
plugin_v.proto
pointcloud.proto
polylinegeom.proto
pose_animation.proto
pose.proto
poses_stamped.proto
pose_stamped.proto
pose_trajectory.proto
pose_v.proto
projector.proto
propagation_grid.proto
propagation_particle.proto
publishers.proto
publish.proto
quaternion.proto
raysensor.proto
request.proto
response.proto
rest_login.proto
rest_logout.proto
rest_post.proto
rest_response.proto
road.proto
scene.proto
selection.proto
sensor_noise.proto
sensor.proto
server_control.proto
shadows.proto
sim_event.proto
sky.proto
sonar.proto
sonar_stamped.proto
spheregeom.proto
spherical_coordinates.proto
stringmsg.proto
stringmsg_v.proto
subscribe.proto
surface.proto
tactile.proto
test.proto
time.proto
topic_info.proto
track_visual.proto
uint32.proto
uint32_v.proto
uint64.proto
uint64_v.proto
undo_redo.proto
user_cmd.proto
user_cmd_stats.proto
vector2d.proto
vector3d.proto
visual.proto
web_request.proto
wind.proto
wireless_node.proto
wireless_nodes.proto
world_control.proto
world_modify.proto
world_reset.proto
world_stats.proto
wrench.proto
wrench_stamped.proto
)

set(PROTO_SRCS)
set(PROTO_HDRS)
set(PROTO_RB)

# Need to add .exe to executable in windows
if (WIN32)
  set(ignmsgs_out_binary "ign_msgs_gen.exe")
else()
  set(ignmsgs_out_binary "ign_msgs_gen")
endif()

foreach(FIL ${msgs})
  get_filename_component(ABS_FIL ${FIL} ABSOLUTE)
  get_filename_component(FIL_WE ${FIL} NAME_WE)

  list(APPEND PROTO_SRCS
    "${CMAKE_CURRENT_BINARY_DIR}/ignition/msgs/${FIL_WE}.pb.cc")
  list(APPEND PROTO_HDRS
    "${CMAKE_CURRENT_BINARY_DIR}/ignition/msgs/${FIL_WE}.pb.h")

  # Add Ruby generation when we start using protobuf 3, which
  # should have a built in ruby generator
  if (WIN32 OR NOT RUBY_PROTOBUF_FOUND)
    add_custom_command(
      OUTPUT
        "${CMAKE_CURRENT_BINARY_DIR}/ignition/msgs/${FIL_WE}.pb.cc"
        "${CMAKE_CURRENT_BINARY_DIR}/ignition/msgs/${FIL_WE}.pb.h"
      COMMAND  ${PROTOBUF_PROTOC_EXECUTABLE}
      ARGS --plugin=protoc-gen-ignmsgs=${CMAKE_BINARY_DIR}/src/${ignmsgs_out_binary}
           --cpp_out=dllexport_decl=IGNITION_MSGS_VISIBLE:${CMAKE_CURRENT_BINARY_DIR}
           --java_out ${CMAKE_CURRENT_BINARY_DIR}
           --ignmsgs_out ${CMAKE_CURRENT_BINARY_DIR}
           --proto_path ${PROJECT_SOURCE_DIR} ${ABS_FIL}
      DEPENDS ${ABS_FIL} ign_msgs_gen
      COMMENT "Running C++, and Java protocol buffer compiler on ${FIL}"
      VERBATIM)
  else()
    list(APPEND PROTO_RB
      "${CMAKE_CURRENT_BINARY_DIR}/ignition/msgs/${FIL_WE}.pb.rb")

    add_custom_command(
      OUTPUT
        "${CMAKE_CURRENT_BINARY_DIR}/ignition/msgs/${FIL_WE}.pb.cc"
        "${CMAKE_CURRENT_BINARY_DIR}/ignition/msgs/${FIL_WE}.pb.h"
        "${CMAKE_CURRENT_BINARY_DIR}/ignition/msgs/${FIL_WE}.pb.rb"

      COMMAND  ${PROTOBUF_PROTOC_EXECUTABLE}
      ARGS --plugin=protoc-gen-ignmsgs=${CMAKE_BINARY_DIR}/src/${ignmsgs_out_binary}
           --cpp_out=dllexport_decl=IGNITION_MSGS_VISIBLE:${CMAKE_CURRENT_BINARY_DIR}
           --java_out=${CMAKE_CURRENT_BINARY_DIR}
           --ruby_out=${CMAKE_CURRENT_BINARY_DIR}
           --ignmsgs_out ${CMAKE_CURRENT_BINARY_DIR}
           --proto_path ${PROJECT_SOURCE_DIR} ${ABS_FIL}
      DEPENDS ${ABS_FIL} ign_msgs_gen
      COMMENT "Running C++, Java, and Ruby protocol buffer compiler on ${FIL}"
      VERBATIM )
  endif()

endforeach()

set_source_files_properties(${PROTO_SRCS} ${PROTO_HDRS}
  PROPERTIES GENERATED TRUE)

link_directories(${IGNITION-MATH_LIBRARY_DIRS})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
ign_add_library(${PROJECT_LIBRARY_TARGET_NAME}
  ${PROTO_SRCS} ${PROJECT_SOURCE_DIR}/src/Factory.cc
  ${PROJECT_SOURCE_DIR}/src/ign.cc
  ${PROJECT_SOURCE_DIR}/src/Utility.cc)
target_link_libraries(${PROJECT_LIBRARY_TARGET_NAME} ${PROTOBUF_LIBRARY}
  ${IGNITION-MATH_LIBRARIES})

if (UNIX)
  # Need to add default visibility to ignition-msgs
  get_target_property(current_property ${PROJECT_LIBRARY_TARGET_NAME}
    COMPILE_FLAGS)

  # property non-existent or empty
  if(NOT current_property)
    set_target_properties(${PROJECT_LIBRARY_TARGET_NAME}
      PROPERTIES GENERATED TRUE
      COMPILE_FLAGS "-fvisibility=default")
  else()
    set_target_properties(${PROJECT_LIBRARY_TARGET_NAME}
      PROPERTIES COMPILE_FLAGS
      "${current_property} -fvisibility=default")
  endif()
endif()

add_dependencies(${PROJECT_LIBRARY_TARGET_NAME} ign_msgs_gen)

set (ign_msgs_headers "" CACHE INTERNAL "Include dirs description")

foreach (hdr ${PROTO_HDRS})
  string (REPLACE "${CMAKE_CURRENT_BINARY_DIR}/" "" hdr ${hdr})
  APPEND_TO_CACHED_STRING(ign_msgs_headers
    "Ignition messages" "#include <${hdr}>\n")
endforeach()

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/ign_auto_headers.hh.in
  ${CMAKE_CURRENT_BINARY_DIR}/MessageTypes.hh)

ign_install_includes(
  "${INCLUDE_INSTALL_DIR_POSTFIX}/ignition/${IGN_PROJECT_NAME}"
  ${CMAKE_CURRENT_BINARY_DIR}/MessageTypes.hh)

# When the minimum CMake required version will be >= 3.1
# we could use the target_compile_features() command
# to enable C++11 support in a platform-independent way.
if(NOT MSVC)
  target_compile_options(${PROJECT_LIBRARY_TARGET_NAME} PUBLIC "-std=c++11")
endif()

target_include_directories(${PROJECT_LIBRARY_TARGET_NAME}
  PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR_FULL}>)

message(STATUS "Installing Ruby messages to ${RUBY_INSTALL_DIR}/ignition/msgs")
install(FILES ${PROTO_RB} DESTINATION ${RUBY_INSTALL_DIR}/ignition/msgs)

ign_install_includes(
  "${INCLUDE_INSTALL_DIR_POSTFIX}/ignition/${IGN_PROJECT_NAME}" ${PROTO_HDRS})
ign_install_library(${PROJECT_LIBRARY_TARGET_NAME} ${PROJECT_EXPORT_NAME})
ign_install_includes(
  "${INCLUDE_INSTALL_DIR_POSTFIX}/ignition/${IGN_PROJECT_NAME}" ${msgs})

=== debian/changelog ===
ignition-msgs (0.5.0-1) unstable; urgency=medium

  * Imported Upstream version 0.5.0

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 12 Sep 2016 17:01:28 +0000

ignition-msgs (0.4.0-3) unstable; urgency=medium

  * Fix typo in VSC browser
  * Fix pkgconfig file name

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Sun, 11 Sep 2016 19:45:38 +0000

ignition-msgs (0.4.0-2) unstable; urgency=medium

  * Added patch to respect CFLAGS
  * Added patch to fix pkgconfig file

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 06 Sep 2016 21:19:33 +0000

ignition-msgs (0.4.0-1) unstable; urgency=medium

  * Imported Upstream version 0.4.0 (Closes: #832042)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 27 Jul 2016 22:29:45 +0000

## ignition-msgs 0.6.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,8 +5,8 @@
 string (SUBSTRING ${PROJECT_NAME} 9 4 IGN_PROJECT_NAME)
 
 string (SUBSTRING ${PROJECT_NAME} 13 -1 PROJECT_MAJOR_VERSION)
-set (PROJECT_MINOR_VERSION 5)
-set (PROJECT_PATCH_VERSION 0)
+set (PROJECT_MINOR_VERSION 6)
+set (PROJECT_PATCH_VERSION 1)
 
 set(PROJECT_NAME_NO_VERSION "ignition-${IGN_PROJECT_NAME}")
 string (TOLOWER ${PROJECT_NAME_NO_VERSION} PROJECT_NAME_NO_VERSION_LOWER)

=== conf/CMakeLists.txt ===
include (${project_cmake_dir}/Utils.cmake)

set(ign_library_path "${CMAKE_BINARY_DIR}/src/cmd/cmdmsgs${PROJECT_MAJOR_VERSION}")

# Generate a configuration file for internal testing.
# Note that the major version of the library is included in the name.
# Ex: transport0.yaml
configure_file(
  "msgs.yaml.in"
    "${CMAKE_BINARY_DIR}/test/conf/msgs${PROJECT_MAJOR_VERSION}.yaml" @ONLY)

set(ign_library_path "${CMAKE_INSTALL_PREFIX}/lib/ruby/ignition/cmdmsgs${PROJECT_MAJOR_VERSION}")

# Generate a configuration file.
# Note that the major version of the library is included in the name.
# Ex: transport0.yaml
configure_file(
  "msgs.yaml.in"
    "${CMAKE_CURRENT_BINARY_DIR}/msgs${PROJECT_MAJOR_VERSION}.yaml" @ONLY)

# Install the yaml configuration files in an unversioned location.
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/msgs${PROJECT_MAJOR_VERSION}.yaml
  DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/ignition/)

=== src/CMakeLists.txt ===
include (${project_cmake_dir}/Utils.cmake)

set (sources
)

set (gtest_sources
  Factory_TEST.cc
  Utility_TEST.cc
)

include_directories (${PROTOBUF_INCLUDE_DIR})
add_executable(ign_msgs_gen Generator.cc generator_main.cc)
target_link_libraries(ign_msgs_gen
  ${PROTOBUF_LIBRARY} ${PROTOBUF_PROTOC_LIBRARY})

if (UNIX)
  target_link_libraries(ign_msgs_gen pthread)
endif()

# When the minimum CMake required version will be >= 3.1 
# we could use the target_compile_features() command 
# to enable C++11 support in a platform-independent way. 
if(NOT MSVC)
  target_compile_options(ign_msgs_gen PUBLIC "-std=c++11")
endif()

link_directories(${IGNITION-MATH_LIBRARY_DIRS}) 
ign_build_tests(${gtest_sources})
add_subdirectory(cmd)

=== ignition/msgs/CMakeLists.txt ===
--- 
+++ 
@@ -112,6 +112,7 @@
 selection.proto
 sensor_noise.proto
 sensor.proto
+sensor_v.proto
 server_control.proto
 shadows.proto
 sim_event.proto
@@ -139,6 +140,7 @@
 vector2d.proto
 vector3d.proto
 visual.proto
+visual_v.proto
 web_request.proto
 wind.proto
 wireless_node.proto

=== include/ignition/CMakeLists.txt ===
add_subdirectory(msgs)

=== src/cmd/CMakeLists.txt ===
include (${project_cmake_dir}/Utils.cmake)

# Generate a the ruby script.
# Note that the major version of the library is included in the name.
# Ex: cmdmsgs0.rb
if (APPLE)
  set(IGN_LIBRARY_NAME lib${PROJECT_NAME_LOWER}.dylib)
else()
  set(IGN_LIBRARY_NAME lib${PROJECT_NAME_LOWER}.so)
endif()
configure_file(
  "cmdmsgs.rb.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmdmsgs${PROJECT_MAJOR_VERSION}.rb" @ONLY)

# Install the ruby command line library in an unversioned location.
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cmdmsgs${PROJECT_MAJOR_VERSION}.rb DESTINATION lib/ruby/ignition)

=== include/ignition/msgs/CMakeLists.txt ===
include (${project_cmake_dir}/Utils.cmake)

set (headers
  Factory.hh
  Generator.hh
  System.hh
  Utility.hh
  ign.hh
)

set (ign_headers "" CACHE INTERNAL "Ignition headers" FORCE)
foreach (hdr ${headers})
  APPEND_TO_CACHED_STRING(ign_headers
    "Ignition headers" "#include <ignition/${IGN_PROJECT_NAME}/${hdr}>\n")
endforeach()

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/ign_auto_headers.hh.in
  ${CMAKE_CURRENT_BINARY_DIR}/msgs.hh)

ign_install_includes("${INCLUDE_INSTALL_DIR_POSTFIX}/ignition"
  ${CMAKE_CURRENT_BINARY_DIR}/msgs.hh)

ign_install_includes(
  "${INCLUDE_INSTALL_DIR_POSTFIX}/ignition/${IGN_PROJECT_NAME}" ${headers})

=== debian/changelog ===
ignition-msgs (0.6.1-1) unstable; urgency=medium

  * Imported Upstream version 0.6.1

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 17 Jan 2017 00:03:26 +0000

=== debian/control ===
Source: ignition-msgs
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Testsuite: autopkgtest
Priority: extra
Build-Depends: cmake,
               pkg-config,
               debhelper (>= 9.20151004),
               libgtest-dev,
               libprotoc-dev,
               libprotobuf-dev (>= 2.3.0),
               libignition-math2-dev,
               protobuf-compiler,
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/ignition-msgs.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/ignition-msgs.git
Homepage: http://ignitionrobotics.org/libraries/msgs

Package: libignition-msgs0
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Set of message definitions used by robotics apps - Shared library
 Ignition msgs is a component in the Ignition framework, a set of
 librariesdesigned to rapidly develop robot applications. The library
 defines common protobuf messages used by the robotics community.
 This package contains the main message library.

Package: libignition-msgs-dev
Architecture: any
Section: libdevel
Depends: libprotobuf-dev (>= 2.3.0),
         libignition-math2-dev,
         libignition-msgs0 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Set of message definitions used by robotics apps - Dev files
 Ignition msgs is a component in the Ignition framework, a set of
 librariesdesigned to rapidly develop robot applications. The library
 defines common protobuf messages used by the robotics community.
 This package contains the headers and other tools for development.

## ignition-msgs 1.0.0%2Bdfsg1

=== debian/changelog ===
ignition-msgs (1.0.0+dfsg1-5) unstable; urgency=medium

  * Include the missing the yaml file to fix current broken ign-tools support

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 09 Mar 2018 17:26:43 +0000

ignition-msgs (1.0.0+dfsg1-4) unstable; urgency=medium

  * Include ruby ignition-tools file in the -dev package

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 09 Mar 2018 12:21:04 +0000

ignition-msgs (1.0.0+dfsg1-3) unstable; urgency=medium

  * Missing protobuf dependencies in -dev package

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 05 Feb 2018 17:03:38 +0000

ignition-msgs (1.0.0+dfsg1-2) unstable; urgency=medium

  * Use ign-math4 instead of ign-math2 and remove deprecated patch

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 22 Jan 2018 16:35:03 +0100

ignition-msgs (1.0.0+dfsg1-1) unstable; urgency=medium

  * Imported Upstream version 1.0.0
  * Migrate metadata to 1.x series

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 05 Jan 2018 20:29:04 +0000

ignition-msgs (0.7.0-1) unstable; urgency=medium

  * Remove merged pkgconfig patch
  * Imported Upstream version 0.7.0

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 05 Sep 2017 22:17:05 +0000

## ignition-msgs 1.0.0+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1 FATAL_ERROR)

#============================================================================
# Initialize the project
#============================================================================
project(ignition-msgs1 VERSION 1.0.0)

#============================================================================
# Find ignition-cmake
#============================================================================
# If you get an error at this line, you need to install ignition-cmake
find_package(ignition-cmake0 REQUIRED)

#============================================================================
# Configure the project
#============================================================================
ign_configure_project()

#============================================================================
# Set project-specific options
#============================================================================

# ignition-msgs currently has no options that are unique to it

#============================================================================
# Search for project-specific dependencies
#============================================================================
message(STATUS "\n\n-- ====== Finding Dependencies ======")

#--------------------------------------
# Find Protobuf
if(MSVC)
  # On Windows we require version 3+ in order to have proper support for
  # shared libraries.
  set(REQ_PROTOBUF_VER 3)
  set(PROTOBUF_PURPOSE "Windows requires version 3+ to ensure proper support for DLLs")
else()
  set(REQ_PROTOBUF_VER 2.3.0)
  set(PROTOBUF_PURPOSE)
endif()
ign_find_package(IgnProtobuf
                 VERSION ${REQ_PROTOBUF_VER}
                 PKGCONFIG protobuf
                 PKGCONFIG_VER_COMPARISON >=
                 REQUIRED
                 PRETTY Protobuf
                 PURPOSE ${PROTOBUF_PURPOSE})

#--------------------------------------
# Find ignition-math
ign_find_package(ignition-math4 REQUIRED)

#--------------------------------------
# Find ignition-tools
ign_find_package(ignition-tools
                 QUIET)

#============================================================================
# Configure the build
#============================================================================
ign_configure_build(QUIT_IF_BUILD_ERRORS)

#============================================================================
# ign command line support
#============================================================================
add_subdirectory(conf)

#============================================================================
# Install proto files
#============================================================================
# TODO: Consider tweaking ign_configure_build() to call add_subdirectory(proto)
# whenever a proto subdirectory exists. This could be used alongside
# ign_msgs_protoc to get uniform support for proto messages across all ignition
# projects.
add_subdirectory(proto)

#============================================================================
# Create package information
#============================================================================
ign_create_packages()

=== conf/CMakeLists.txt ===
set(ign_library_path "${CMAKE_BINARY_DIR}/src/cmd/cmdmsgs${PROJECT_VERSION_MAJOR}")

# Generate a configuration file for internal testing.
# Note that the major version of the library is included in the name.
# Ex: transport0.yaml
configure_file(
  "msgs.yaml.in"
  "${CMAKE_BINARY_DIR}/test/conf/msgs${PROJECT_VERSION_MAJOR}.yaml" @ONLY)

set(ign_library_path "${CMAKE_INSTALL_PREFIX}/lib/ruby/ignition/cmdmsgs${PROJECT_VERSION_MAJOR}")

# Generate a configuration file.
# Note that the major version of the library is included in the name.
# Ex: transport0.yaml
configure_file(
  "msgs.yaml.in"
  "${CMAKE_CURRENT_BINARY_DIR}/msgs${PROJECT_VERSION_MAJOR}.yaml" @ONLY)

# Install the yaml configuration files in an unversioned location.
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/msgs${PROJECT_VERSION_MAJOR}.yaml
  DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/ignition/)

=== src/CMakeLists.txt ===
##################################################
# Build a custom protoc plugin
ign_add_executable(ign_msgs_gen Generator.cc generator_main.cc)
target_link_libraries(ign_msgs_gen
  protobuf::libprotobuf 
  protobuf::libprotoc)
target_include_directories(ign_msgs_gen PRIVATE ${PROTOBUF_INCLUDE_DIR})
target_compile_features(ign_msgs_gen PRIVATE ${IGN_CXX_11_FEATURES})

if (UNIX)
  target_link_libraries(ign_msgs_gen pthread)
endif()


##################################################
# A function that calls protoc on a protobuf file
# Options:
#   GENERATE_RUBY       - generates ruby code for the message if specified
#   GENERATE_CPP        - generates c++ code for the message if specified
# One value arguments:
#   PROTO_PACKAGE       - Protobuf package the file belongs to (e.g. ".ignition.msgs")
#   PROTOC_EXEC         - Path to protoc
#   INPUT_PROTO         - Path to the input .proto file
#   OUTPUT_CPP_DIR      - Path where C++ files are saved
#   OUTPUT_RUBY_DIR     - Path where Ruby files are saved
#   OUTPUT_CPP_HH_VAR   - A CMake variable name containing a list that the C++ header path should be appended to
#   OUTPUT_CPP_CC_VAR   - A Cmake variable name containing a list that the C++ source path should be appended to
#   OUTPUT_RUBY_VAR     - A Cmake variable name containing a list that the ruby file should be apenned to
# Multi value arguments
#   PROTO_PATH          - Passed to protoc --proto_path
function(ign_msgs_protoc)
  set(options GENERATE_RUBY GENERATE_CPP)
  set(oneValueArgs PROTO_PACKAGE PROTOC_EXEC INPUT_PROTO OUTPUT_CPP_DIR OUTPUT_RUBY_DIR OUTPUT_CPP_HH_VAR OUTPUT_CPP_CC_VAR OUTPUT_RUBY_VAR)
  set(multiValueArgs PROTO_PATH)

  cmake_parse_arguments(ign_msgs_protoc "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

  get_filename_component(ABS_FIL ${ign_msgs_protoc_INPUT_PROTO} ABSOLUTE)
  get_filename_component(FIL_WE ${ign_msgs_protoc_INPUT_PROTO} NAME_WE)

  set(protoc_args)
  set(output_files)

  foreach(proto_path ${ign_msgs_protoc_PROTO_PATH})
    list(APPEND protoc_args "--proto_path=${proto_path}")
  endforeach()

  set(proto_package_dir ".")
  if(ign_msgs_protoc_PROTO_PACKAGE)
    string(REPLACE "." "/" proto_package_dir ${ign_msgs_protoc_PROTO_PACKAGE})
  endif()

  if(ign_msgs_protoc_GENERATE_CPP)
    set(output_header "${ign_msgs_protoc_OUTPUT_CPP_DIR}${proto_package_dir}/${FIL_WE}.pb.h")
    set(output_source "${ign_msgs_protoc_OUTPUT_CPP_DIR}${proto_package_dir}/${FIL_WE}.pb.cc")
    list(APPEND ${ign_msgs_protoc_OUTPUT_CPP_HH_VAR} ${output_header})
    list(APPEND ${ign_msgs_protoc_OUTPUT_CPP_CC_VAR} ${output_source})
    list(APPEND output_files ${output_header})
    list(APPEND output_files ${output_source})
    list(APPEND protoc_args "--plugin=protoc-gen-ignmsgs=$<TARGET_FILE:ign_msgs_gen>")
    list(APPEND protoc_args "--cpp_out=dllexport_decl=IGNITION_MSGS_VISIBLE:${ign_msgs_protoc_OUTPUT_CPP_DIR}")
    list(APPEND protoc_args "--ignmsgs_out" "${ign_msgs_protoc_OUTPUT_CPP_DIR}")
    set(${ign_msgs_protoc_OUTPUT_CPP_HH_VAR} ${${ign_msgs_protoc_OUTPUT_CPP_HH_VAR}} PARENT_SCOPE)
    set(${ign_msgs_protoc_OUTPUT_CPP_CC_VAR} ${${ign_msgs_protoc_OUTPUT_CPP_CC_VAR}} PARENT_SCOPE)
  endif()

  if(ign_msgs_protoc_GENERATE_RUBY)
    set(output_ruby "${ign_msgs_protoc_OUTPUT_RUBY_DIR}${proto_package_dir}/${FIL_WE}.pb.rb")
    list(APPEND ${ign_msgs_protoc_OUTPUT_RUBY_VAR} ${output_ruby})
    list(APPEND output_files ${output_ruby})
    list(APPEND protoc_args "--ruby_out=${ign_msgs_protoc_OUTPUT_RUBY_DIR}")
    set(${ign_msgs_protoc_OUTPUT_RUBY_VAR} ${${ign_msgs_protoc_OUTPUT_RUBY_VAR}} PARENT_SCOPE)
  endif()

  #get_cmake_property(_variableNames VARIABLES)
  #foreach (_variableName ${_variableNames})
  #    message(STATUS "${_variableName}=${${_variableName}}")
  #endforeach()

  add_custom_command(
    OUTPUT
      ${output_files}
    COMMAND
      ${ign_msgs_protoc_PROTOC_EXEC}
    ARGS
      ${protoc_args}
      ${ABS_FIL}
    DEPENDS
      ${ABS_FIL}
      ign_msgs_gen
    COMMENT "Running protoc on ${ign_msgs_protoc_INPUT_PROTO}"
    VERBATIM)
endfunction()


##################################################
# do the code generation
set(proto_headers)
set(proto_sources)
set(proto_ruby_scripts)

file (GLOB proto_files ${PROJECT_SOURCE_DIR}/proto/ignition/msgs/*.proto)

set(gen_ruby GENERATE_RUBY)
if(WIN32 OR NOT RUBY_PROTOBUF_FOUND)
  set(gen_ruby)
endif()

foreach(proto_file ${proto_files})
  ign_msgs_protoc(
    PROTO_PACKAGE
      .ignition.msgs
    GENERATE_CPP
      ${gen_ruby}
    INPUT_PROTO
      ${proto_file}
    PROTOC_EXEC
      protobuf::protoc
    OUTPUT_CPP_DIR
      "${PROJECT_BINARY_DIR}/include"
    OUTPUT_RUBY_DIR
      "${CMAKE_CURRENT_BINARY_DIR}"
    OUTPUT_CPP_HH_VAR
      gen_headers
    OUTPUT_CPP_CC_VAR
      gen_sources
    OUTPUT_RUBY_VAR
      gen_ruby_scripts
    PROTO_PATH
      "${PROJECT_SOURCE_DIR}/proto")
endforeach()

if(NOT MSVC)
  # -Wno-switch-default flags is required for suppressing a warning in some of
  # the generated protobuf files.
  set_source_files_properties(${gen_sources} COMPILE_FLAGS -Wno-switch-default)
endif()

if(MSVC)
  # Warning #4251 is the "dll-interface" warning that tells you when types used
  # by a class are not being exported. These generated source files have private
  # members that don't get exported, so they trigger this warning. However, the
  # warning is not important since those members do not need to be interfaced
  # with.
  set_source_files_properties(${gen_sources} COMPILE_FLAGS "/wd4251 /wd4146")
endif()

set_source_files_properties(${gen_headers} ${gen_sources} ${gen_ruby_scripts}
  PROPERTIES GENERATED TRUE)

message(STATUS "Installing Ruby messages to ${RUBY_INSTALL_DIR}/ignition/${IGN_DESIGNATION}")
install(FILES ${proto_ruby_scripts} DESTINATION ${RUBY_INSTALL_DIR}/ignition/${IGN_DESIGNATION})

ign_install_includes(
  "${IGN_INCLUDE_INSTALL_DIR_POSTFIX}/ignition/${IGN_DESIGNATION}"
  ${gen_headers})


##################################################
# Generate ignition/msgs/MessageTypes.hh
foreach (hdr ${gen_headers})
  string(REPLACE "${PROJECT_BINARY_DIR}/include/" "" hdr ${hdr})
  string(CONCAT ign_msgs_headers ${ign_msgs_headers} "#include <${hdr}>\n")
endforeach()

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/MessageTypes.hh.in
  ${PROJECT_BINARY_DIR}/include/ignition/msgs/MessageTypes.hh)

ign_install_includes(
  "${IGN_INCLUDE_INSTALL_DIR_POSTFIX}/ignition/${IGN_DESIGNATION}"
  "${PROJECT_BINARY_DIR}/include/ignition/${IGN_DESIGNATION}/MessageTypes.hh")


##################################################
# Build the main library
ign_add_library(${PROJECT_LIBRARY_TARGET_NAME}
  ${gen_sources}
  ${PROJECT_SOURCE_DIR}/src/Factory.cc
  ${PROJECT_SOURCE_DIR}/src/ign.cc
  ${PROJECT_SOURCE_DIR}/src/Utility.cc)

target_compile_features(${PROJECT_LIBRARY_TARGET_NAME} PRIVATE ${IGN_CXX_11_FEATURES})

target_include_directories(${PROJECT_LIBRARY_TARGET_NAME}
  PRIVATE
    ${CMAKE_CURRENT_BINARY_DIR})

target_link_libraries(${PROJECT_LIBRARY_TARGET_NAME}
  PUBLIC
    protobuf::libprotobuf
    ${ignition-math4_LIBRARIES})

target_include_directories(${PROJECT_LIBRARY_TARGET_NAME}
  SYSTEM PUBLIC $<TARGET_PROPERTY:protobuf::libprotobuf,INTERFACE_INCLUDE_DIRECTORIES>)

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  # Disable warning in generated *.pb.cc code
  target_compile_options(${PROJECT_LIBRARY_TARGET_NAME} PRIVATE -Wno-extended-offsetof)
endif()

target_include_directories(${PROJECT_LIBRARY_TARGET_NAME}
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
    $<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR_FULL}>)

ign_install_library()


##################################################
# Build unit tests
ign_get_libsources_and_unittests(sources gtest_sources)

# Build the unit tests.
ign_build_tests(TYPE UNIT
  SOURCES
    ${gtest_sources})

##################################################
# ign msgs command
add_subdirectory(cmd)

=== test/CMakeLists.txt ===
include_directories (
  ${PROJECT_SOURCE_DIR}/test/gtest/include
  ${PROJECT_SOURCE_DIR}/test/gtest
  ${PROJECT_SOURCE_DIR}/test
)

configure_file (test_config.h.in ${PROJECT_BINARY_DIR}/test_config.h)

# Build gtest
add_library(gtest STATIC gtest/src/gtest-all.cc)
target_compile_features(gtest PUBLIC cxx_variadic_macros)
add_library(gtest_main STATIC gtest/src/gtest_main.cc)
target_link_libraries(gtest_main gtest)
set(GTEST_LIBRARY "${PROJECT_BINARY_DIR}/test/libgtest.a")
set(GTEST_MAIN_LIBRARY "${PROJECT_BINARY_DIR}/test/libgtest_main.a")

execute_process(COMMAND cmake -E remove_directory ${CMAKE_BINARY_DIR}/test_results)
execute_process(COMMAND cmake -E make_directory ${CMAKE_BINARY_DIR}/test_results)
include_directories(${GTEST_INCLUDE_DIRS})

add_subdirectory(integration)
add_subdirectory(performance)
add_subdirectory(regression)

=== src/cmd/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,3 @@
-include (${project_cmake_dir}/Utils.cmake)
-
 # Generate a the ruby script.
 # Note that the major version of the library is included in the name.
 # Ex: cmdmsgs0.rb

=== debian/control ===
--- 
+++ 
@@ -2,22 +2,22 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
 Section: science
-Testsuite: autopkgtest
-Priority: extra
+Priority: optional
 Build-Depends: cmake,
                pkg-config,
-               debhelper (>= 9.20151004),
+               debhelper (>= 11),
                libgtest-dev,
                libprotoc-dev,
                libprotobuf-dev (>= 2.3.0),
-               libignition-math2-dev,
+               libignition-math4-dev,
+               libignition-cmake-dev,
                protobuf-compiler,
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/ignition-msgs.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/ignition-msgs.git
 Homepage: http://ignitionrobotics.org/libraries/msgs
 
-Package: libignition-msgs0
+Package: libignition-msgs
 Architecture: any
 Section: libs
 Pre-Depends: ${misc:Pre-Depends}
@@ -33,8 +33,11 @@
 Architecture: any
 Section: libdevel
 Depends: libprotobuf-dev (>= 2.3.0),
-         libignition-math2-dev,
-         libignition-msgs0 (= ${binary:Version}),
+         libprotoc-dev,
+         protobuf-compiler,
+         libignition-math4-dev,
+         libignition-cmake-dev,
+         libignition-msgs (= ${binary:Version}),
          ${misc:Depends}
 Multi-Arch: same
 Description: Set of message definitions used by robotics apps - Dev files

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

.PHONY: override_dh_auto_configure

override_dh_auto_configure:
	dh_auto_configure -- \
                -DUSE_HOST_CFLAGS:BOOL=False \
                -DUSE_UPSTREAM_CFLAGS:BOOL=False \
                -DCMAKE_BUILD_TYPE=RelWithDebInfo

%:
	dh $@ --buildsystem=cmake --parallel

=== debian/tests/control ===
Tests: build
Depends: libignition-msgs-dev, pkg-config, build-essential
